﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace GettingCarouselInstanceFromPanelTemplate
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Search for RadCarouselPanel when lstThumbs is loaded
		/// </summary>
		private void lstThumbs_Loaded(object sender, RoutedEventArgs e)
		{
			RadCarouselPanel panel = this.GetCarouselPanel();

			// set panel properties
			panel.ItemsPerPage = 3;
		}

		/// <summary>
		/// Retrieves the RadCarouselPanel from the visual tree
		/// </summary>
		/// <returns>RadCarouselPanel is found, null otherwise</returns>
		private RadCarouselPanel GetCarouselPanel()
		{
			RadCarouselPanel panel = null;

			// searches for the ItemsPresenter of our ItemsControl 
			ItemsPresenter presenter = FindChildByType<ItemsPresenter>(this.lstThumbs);

			if (presenter != null)
				// searches for a visual element named RadCarouselPanel in the template of the ItemsPresenter
				panel = (RadCarouselPanel)this.lstThumbs.ItemsPanel.FindName("RadCarouselPanel", presenter);

			return panel;
		}

		/// <summary>
		/// Searches for a visual child of a specified type
		/// </summary>
		/// <typeparam name="T">The type of child to search for</typeparam>
		/// <param name="parent">Parent object to start searching from</param>
		/// <returns>Object of type T if found, null otherwise</returns>
		private static T FindChildByType<T>(DependencyObject parent) where T : DependencyObject
		{
			T targetChild = default(T);
			int childrenCount = VisualTreeHelper.GetChildrenCount(parent);

			for (int i = 0; i < childrenCount; i++)
			{
				DependencyObject currentChild = VisualTreeHelper.GetChild(parent, i);
				targetChild = currentChild as T;

				if (targetChild == null)
					targetChild = FindChildByType<T>(currentChild);

				if (targetChild != null)
					return targetChild;
			}

			return targetChild;
		}
	}
}
